# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

Name:           selenium
Version:        2.2.0
Release:        1%{?dist}
Epoch:          0
Summary:        Selenium browser automation
License:        Apache Software License 2.0
Group:          Development/Java
URL:            http://seleniumhq.org/
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch
Source0:        selenium-2.2.0.tgz
# svn export http://selenium.googlecode.com/svn/tags/selenium-2.2.0/
# tar czf ../SOURCES/selenium-2.2.0.tgz selenium-2.2.0/

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Patch0:         selenium-Rakefile.patch
Patch1:         selenium-CertificateCreator.patch
Patch2:         selenium-ResultConfig.patch

BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-clean
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin

BuildRequires:  apache-commons-io
BuildRequires:  bouncycastle
BuildRequires:  cglib21
BuildRequires:  guava
BuildRequires:  hamcrest
BuildRequires:  hc-httpclient
BuildRequires:  hc-project
BuildRequires:  htmlunit2
BuildRequires:  james-project
BuildRequires:  jna
BuildRequires:  json
BuildRequires:  junit4
BuildRequires:  oss-parent
BuildRequires:  servlet_2_5_api
BuildRequires:  snakeyaml
BuildRequires:  testng

Requires:  java >= 0:1.6.0
Requires:  apache-commons-io
Requires:  bouncycastle
Requires:  cglib21
Requires:  guava
Requires:  hamcrest
Requires:  hc-httpclient
Requires:  hc-project
Requires:  htmlunit2
Requires:  jna
Requires:  json
Requires:  junit4
Requires:  servlet_2_5_api
Requires:  snakeyaml
Requires:  testng

%description
Selenium is a suite of tools specifically for automating web
browsers.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q 
cp -p %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2

%build
./go release

export CLASSPATH=
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}/
export MAVEN_SETTINGS=$(pwd)/settings.xml
mkdir external_repo
ln -s %{_javadir} external_repo/JPP

cd maven
%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven.test.failure.ignore=true \
        install javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

cd maven
# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 0644 api/target/selenium-api-2.0-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/api-%{version}.jar
install -m 0644 android-driver/target/selenium-android-driver-2.0-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/android-driver-%{version}.jar
install -m 0644 chrome-driver/target/selenium-chrome-driver-2.0-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/chrome-driver-%{version}.jar
install -m 0644 firefox-driver/target/selenium-firefox-driver-2.0-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/firefox-driver-%{version}.jar
install -m 0644 htmlunit-driver/target/selenium-htmlunit-driver-2.0-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/htmlunit-driver-%{version}.jar
install -m 0644 ie-driver/target/selenium-ie-driver-2.0-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/ie-driver-%{version}.jar
install -m 0644 iphone-driver/target/selenium-iphone-driver-2.0-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/iphone-driver-%{version}.jar
install -m 0644 remote-driver/target/selenium-remote-driver-2.0-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/remote-driver-%{version}.jar
install -m 0644 java/target/selenium-java-2.0-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/java-%{version}.jar
install -m 0644 server/target/selenium-server-2.0-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/server-%{version}.jar
install -m 0644 support/target/selenium-support-2.0-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/support-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name}
for jar in *-%{version}*.jar; do ln -sf ${jar} `echo ${jar} | sed "s|-%{version}||g"`;done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-parent.pom
%add_to_maven_depmap org.seleniumhq.selenium selenium-parent %{version} JPP/%{name} parent
install -m 644 api/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-api.pom
%add_to_maven_depmap org.seleniumhq.selenium selenium-api %{version} JPP/%{name} api
install -m 644 android-driver/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-android-driver.pom
%add_to_maven_depmap org.seleniumhq.selenium selenium-android-driver %{version} JPP/%{name} android-driver
install -m 644 chrome-driver/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-chrome-driver.pom
%add_to_maven_depmap org.seleniumhq.selenium selenium-chrome-driver %{version} JPP/%{name} chrome-driver
install -m 644 firefox-driver/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-firefox-driver.pom
%add_to_maven_depmap org.seleniumhq.selenium selenium-firefox-driver %{version} JPP/%{name} firefox-driver
install -m 644 htmlunit-driver/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-htmlunit-driver.pom
%add_to_maven_depmap org.seleniumhq.selenium selenium-htmlunit-driver %{version} JPP/%{name} htmlunit-driver
install -m 644 ie-driver/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-ie-driver.pom
%add_to_maven_depmap org.seleniumhq.selenium selenium-ie-driver %{version} JPP/%{name} ie-driver
install -m 644 iphone-driver/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-iphone-driver.pom
%add_to_maven_depmap org.seleniumhq.selenium selenium-iphone-driver %{version} JPP/%{name} iphone-driver
install -m 644 remote-driver/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-remote-driver.pom
%add_to_maven_depmap org.seleniumhq.selenium selenium-remote-driver %{version} JPP/%{name} remote-driver
install -m 644 java/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-java.pom
%add_to_maven_depmap org.seleniumhq.selenium selenium-java %{version} JPP/%{name} java
install -m 644 server/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-server.pom
%add_to_maven_depmap org.seleniumhq.selenium selenium-server %{version} JPP/%{name} server
install -m 644 support/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-support.pom
%add_to_maven_depmap org.seleniumhq.selenium selenium-support %{version} JPP/%{name} support

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/*

%changelog
* Wed Nov 02 2011 Ralph Apel <r.apel@r-apel.de> 0:2.2.0-1
- first release 

